---
title: Mitigate detections
description: Datadog, the leading service for cloud-scale monitoring.
breadcrumbs: Docs > API Reference > Governance Console
---

> For the complete documentation index, see [llms.txt](https://docs.datadoghq.com/llms.txt).

# Mitigate detections{% #mitigate-detections %}
Copy pageCopied
{% tab title="v2" %}
**Note**: This endpoint is in preview and is subject to change. If you have any feedback, contact [Datadog support](https://docs.datadoghq.com/help/).
| Datadog site      | API endpoint                                                             |
| ----------------- | ------------------------------------------------------------------------ |
| ap1.datadoghq.com | POST https://api.ap1.datadoghq.com/api/v2/governance/detections/mitigate |
| ap2.datadoghq.com | POST https://api.ap2.datadoghq.com/api/v2/governance/detections/mitigate |
| app.datadoghq.eu  | POST https://api.datadoghq.eu/api/v2/governance/detections/mitigate      |
| app.ddog-gov.com  | POST https://api.ddog-gov.com/api/v2/governance/detections/mitigate      |
| us2.ddog-gov.com  | POST https://api.us2.ddog-gov.com/api/v2/governance/detections/mitigate  |
| uk1.datadoghq.com | POST https://api.uk1.datadoghq.com/api/v2/governance/detections/mitigate |
| app.datadoghq.com | POST https://api.datadoghq.com/api/v2/governance/detections/mitigate     |
| us3.datadoghq.com | POST https://api.us3.datadoghq.com/api/v2/governance/detections/mitigate |
| us5.datadoghq.com | POST https://api.us5.datadoghq.com/api/v2/governance/detections/mitigate |

### Overview

Apply a mitigation to a set of governance detections of a given detection type. When the mitigation type is omitted, the control's configured mitigation is used. The request is accepted for asynchronous processing. This endpoint requires the `governance_console_read` permission.

### Request

#### Body Data (required)



{% tab title="Model" %}

| Parent field | Field                            | Type     | Description                                                                                                       |
| ------------ | -------------------------------- | -------- | ----------------------------------------------------------------------------------------------------------------- |
|              | data [*required*]           | object   | The data of a governance mitigation request.                                                                      |
| data         | attributes                       | object   | The attributes of a governance mitigation request.                                                                |
| attributes   | detection_ids [*required*]  | [string] | The identifiers of the detections to mitigate in this request.                                                    |
| attributes   | detection_type [*required*] | string   | The detection type whose detections should be mitigated.                                                          |
| attributes   | mitigation_parameters            | object   | A free-form map of parameter names to their configured values.                                                    |
| attributes   | mitigation_type                  | string   | The mitigation to apply to the selected detections. Defaults to the control's configured mitigation when omitted. |
| data         | type [*required*]           | enum     | Governance control detection resource type. Allowed enum values: `governance_control_detection`                   |

{% /tab %}

{% tab title="Example" %}

```json
{
  "data": {
    "attributes": {
      "detection_ids": [
        "3f9b2c1a-8d4e-4a6b-9c2f-1e7d5a0b3c4d"
      ],
      "detection_type": "unused_api_keys",
      "mitigation_parameters": {},
      "mitigation_type": "revoke_api_key"
    },
    "type": "governance_control_detection"
  }
}
```

{% /tab %}

### Response

{% tab title="202" %}
Accepted
{% /tab %}

{% tab title="400" %}
Bad Request
{% tab title="Model" %}
API error response.

| Parent field | Field                    | Type     | Description                                                                     |
| ------------ | ------------------------ | -------- | ------------------------------------------------------------------------------- |
|              | errors [*required*] | [object] | A list of errors.                                                               |
| errors       | detail                   | string   | A human-readable explanation specific to this occurrence of the error.          |
| errors       | meta                     | object   | Non-standard meta-information about the error                                   |
| errors       | source                   | object   | References to the source of the error.                                          |
| source       | header                   | string   | A string indicating the name of a single request header which caused the error. |
| source       | parameter                | string   | A string indicating which URI query parameter caused the error.                 |
| source       | pointer                  | string   | A JSON pointer to the value in the request document that caused the error.      |
| errors       | status                   | string   | Status code of the response.                                                    |
| errors       | title                    | string   | Short human-readable summary of the error.                                      |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    {
      "detail": "Missing required attribute in body",
      "meta": {},
      "source": {
        "header": "Authorization",
        "parameter": "limit",
        "pointer": "/data/attributes/title"
      },
      "status": "400",
      "title": "Bad Request"
    }
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="401" %}
Unauthorized
{% tab title="Model" %}
API error response.

| Parent field | Field                    | Type     | Description                                                                     |
| ------------ | ------------------------ | -------- | ------------------------------------------------------------------------------- |
|              | errors [*required*] | [object] | A list of errors.                                                               |
| errors       | detail                   | string   | A human-readable explanation specific to this occurrence of the error.          |
| errors       | meta                     | object   | Non-standard meta-information about the error                                   |
| errors       | source                   | object   | References to the source of the error.                                          |
| source       | header                   | string   | A string indicating the name of a single request header which caused the error. |
| source       | parameter                | string   | A string indicating which URI query parameter caused the error.                 |
| source       | pointer                  | string   | A JSON pointer to the value in the request document that caused the error.      |
| errors       | status                   | string   | Status code of the response.                                                    |
| errors       | title                    | string   | Short human-readable summary of the error.                                      |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    {
      "detail": "Missing required attribute in body",
      "meta": {},
      "source": {
        "header": "Authorization",
        "parameter": "limit",
        "pointer": "/data/attributes/title"
      },
      "status": "400",
      "title": "Bad Request"
    }
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="403" %}
Forbidden
{% tab title="Model" %}
API error response.

| Parent field | Field                    | Type     | Description                                                                     |
| ------------ | ------------------------ | -------- | ------------------------------------------------------------------------------- |
|              | errors [*required*] | [object] | A list of errors.                                                               |
| errors       | detail                   | string   | A human-readable explanation specific to this occurrence of the error.          |
| errors       | meta                     | object   | Non-standard meta-information about the error                                   |
| errors       | source                   | object   | References to the source of the error.                                          |
| source       | header                   | string   | A string indicating the name of a single request header which caused the error. |
| source       | parameter                | string   | A string indicating which URI query parameter caused the error.                 |
| source       | pointer                  | string   | A JSON pointer to the value in the request document that caused the error.      |
| errors       | status                   | string   | Status code of the response.                                                    |
| errors       | title                    | string   | Short human-readable summary of the error.                                      |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    {
      "detail": "Missing required attribute in body",
      "meta": {},
      "source": {
        "header": "Authorization",
        "parameter": "limit",
        "pointer": "/data/attributes/title"
      },
      "status": "400",
      "title": "Bad Request"
    }
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="429" %}
Too many requests
{% tab title="Model" %}
API error response.

| Field                    | Type     | Description       |
| ------------------------ | -------- | ----------------- |
| errors [*required*] | [string] | A list of errors. |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    "Bad Request"
  ]
}
```

{% /tab %}

{% /tab %}

### Code Example

##### 
                  \## default
# 
 \# Curl command curl -X POST "https://api.datadoghq.com/api/v2/governance/detections/mitigate" \
-H "Accept: application/json" \
-H "Content-Type: application/json" \
-H "DD-API-KEY: ${DD_API_KEY}" \
-H "DD-APPLICATION-KEY: ${DD_APP_KEY}" \
-d @- << EOF
{
  "data": {
    "attributes": {
      "detection_ids": [
        "3f9b2c1a-8d4e-4a6b-9c2f-1e7d5a0b3c4d"
      ],
      "detection_type": "unused_api_keys",
      "mitigation_parameters": {},
      "mitigation_type": "revoke_api_key"
    },
    "type": "governance_control_detection"
  }
}
EOF 
                
##### 

```python
"""
Mitigate detections returns "Accepted" response
"""

from datadog_api_client import ApiClient, Configuration
from datadog_api_client.v2.api.governance_console_api import GovernanceConsoleApi
from datadog_api_client.v2.model.governance_control_detection_resource_type import (
    GovernanceControlDetectionResourceType,
)
from datadog_api_client.v2.model.governance_mitigation_request import GovernanceMitigationRequest
from datadog_api_client.v2.model.governance_mitigation_request_attributes import GovernanceMitigationRequestAttributes
from datadog_api_client.v2.model.governance_mitigation_request_data import GovernanceMitigationRequestData

body = GovernanceMitigationRequest(
    data=GovernanceMitigationRequestData(
        attributes=GovernanceMitigationRequestAttributes(
            detection_ids=[
                "3f9b2c1a-8d4e-4a6b-9c2f-1e7d5a0b3c4d",
            ],
            detection_type="unused_api_keys",
            mitigation_type="revoke_api_key",
        ),
        type=GovernanceControlDetectionResourceType.GOVERNANCE_CONTROL_DETECTION,
    ),
)

configuration = Configuration()
configuration.unstable_operations["mitigate_governance_detections"] = True
with ApiClient(configuration) as api_client:
    api_instance = GovernanceConsoleApi(api_client)
    api_instance.mitigate_governance_detections(body=body)
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=python) and then save the example to `example.py` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" python3 "example.py"
##### 

```ruby
# Mitigate detections returns "Accepted" response

require "datadog_api_client"
DatadogAPIClient.configure do |config|
  config.unstable_operations["v2.mitigate_governance_detections".to_sym] = true
end
api_instance = DatadogAPIClient::V2::GovernanceConsoleAPI.new

body = DatadogAPIClient::V2::GovernanceMitigationRequest.new({
  data: DatadogAPIClient::V2::GovernanceMitigationRequestData.new({
    attributes: DatadogAPIClient::V2::GovernanceMitigationRequestAttributes.new({
      detection_ids: [
        "3f9b2c1a-8d4e-4a6b-9c2f-1e7d5a0b3c4d",
      ],
      detection_type: "unused_api_keys",
      mitigation_type: "revoke_api_key",
    }),
    type: DatadogAPIClient::V2::GovernanceControlDetectionResourceType::GOVERNANCE_CONTROL_DETECTION,
  }),
})
p api_instance.mitigate_governance_detections(body)
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=ruby) and then save the example to `example.rb` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" rb "example.rb"
##### 

```go
// Mitigate detections returns "Accepted" response

package main

import (
	"context"
	"fmt"
	"os"

	"github.com/DataDog/datadog-api-client-go/v2/api/datadog"
	"github.com/DataDog/datadog-api-client-go/v2/api/datadogV2"
)

func main() {
	body := datadogV2.GovernanceMitigationRequest{
		Data: datadogV2.GovernanceMitigationRequestData{
			Attributes: &datadogV2.GovernanceMitigationRequestAttributes{
				DetectionIds: []string{
					"3f9b2c1a-8d4e-4a6b-9c2f-1e7d5a0b3c4d",
				},
				DetectionType:  "unused_api_keys",
				MitigationType: datadog.PtrString("revoke_api_key"),
			},
			Type: datadogV2.GOVERNANCECONTROLDETECTIONRESOURCETYPE_GOVERNANCE_CONTROL_DETECTION,
		},
	}
	ctx := datadog.NewDefaultContext(context.Background())
	configuration := datadog.NewConfiguration()
	configuration.SetUnstableOperationEnabled("v2.MitigateGovernanceDetections", true)
	apiClient := datadog.NewAPIClient(configuration)
	api := datadogV2.NewGovernanceConsoleApi(apiClient)
	r, err := api.MitigateGovernanceDetections(ctx, body)

	if err != nil {
		fmt.Fprintf(os.Stderr, "Error when calling `GovernanceConsoleApi.MitigateGovernanceDetections`: %v\n", err)
		fmt.Fprintf(os.Stderr, "Full HTTP response: %v\n", r)
	}
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=go) and then save the example to `main.go` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" go run "main.go"
##### 

```java
// Mitigate detections returns "Accepted" response

import com.datadog.api.client.ApiClient;
import com.datadog.api.client.ApiException;
import com.datadog.api.client.v2.api.GovernanceConsoleApi;
import com.datadog.api.client.v2.model.GovernanceControlDetectionResourceType;
import com.datadog.api.client.v2.model.GovernanceMitigationRequest;
import com.datadog.api.client.v2.model.GovernanceMitigationRequestAttributes;
import com.datadog.api.client.v2.model.GovernanceMitigationRequestData;
import java.util.Collections;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = ApiClient.getDefaultApiClient();
    defaultClient.setUnstableOperationEnabled("v2.mitigateGovernanceDetections", true);
    GovernanceConsoleApi apiInstance = new GovernanceConsoleApi(defaultClient);

    GovernanceMitigationRequest body =
        new GovernanceMitigationRequest()
            .data(
                new GovernanceMitigationRequestData()
                    .attributes(
                        new GovernanceMitigationRequestAttributes()
                            .detectionIds(
                                Collections.singletonList("3f9b2c1a-8d4e-4a6b-9c2f-1e7d5a0b3c4d"))
                            .detectionType("unused_api_keys")
                            .mitigationType("revoke_api_key"))
                    .type(GovernanceControlDetectionResourceType.GOVERNANCE_CONTROL_DETECTION));

    try {
      apiInstance.mitigateGovernanceDetections(body);
    } catch (ApiException e) {
      System.err.println(
          "Exception when calling GovernanceConsoleApi#mitigateGovernanceDetections");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=java) and then save the example to `Example.java` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" java "Example.java"
##### 

```rust
// Mitigate detections returns "Accepted" response
use datadog_api_client::datadog;
use datadog_api_client::datadogV2::api_governance_console::GovernanceConsoleAPI;
use datadog_api_client::datadogV2::model::GovernanceControlDetectionResourceType;
use datadog_api_client::datadogV2::model::GovernanceMitigationRequest;
use datadog_api_client::datadogV2::model::GovernanceMitigationRequestAttributes;
use datadog_api_client::datadogV2::model::GovernanceMitigationRequestData;

#[tokio::main]
async fn main() {
    let body = GovernanceMitigationRequest::new(
        GovernanceMitigationRequestData::new(
            GovernanceControlDetectionResourceType::GOVERNANCE_CONTROL_DETECTION,
        )
        .attributes(
            GovernanceMitigationRequestAttributes::new(
                vec!["3f9b2c1a-8d4e-4a6b-9c2f-1e7d5a0b3c4d".to_string()],
                "unused_api_keys".to_string(),
            )
            .mitigation_type("revoke_api_key".to_string()),
        ),
    );
    let mut configuration = datadog::Configuration::new();
    configuration.set_unstable_operation_enabled("v2.MitigateGovernanceDetections", true);
    let api = GovernanceConsoleAPI::with_config(configuration);
    let resp = api.mitigate_governance_detections(body).await;
    if let Ok(value) = resp {
        println!("{:#?}", value);
    } else {
        println!("{:#?}", resp.unwrap_err());
    }
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=rust) and then save the example to `src/main.rs` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" cargo run
##### 

```typescript
/**
 * Mitigate detections returns "Accepted" response
 */

import { client, v2 } from "@datadog/datadog-api-client";

const configuration = client.createConfiguration();
configuration.unstableOperations["v2.mitigateGovernanceDetections"] = true;
const apiInstance = new v2.GovernanceConsoleApi(configuration);

const params: v2.GovernanceConsoleApiMitigateGovernanceDetectionsRequest = {
  body: {
    data: {
      attributes: {
        detectionIds: ["3f9b2c1a-8d4e-4a6b-9c2f-1e7d5a0b3c4d"],
        detectionType: "unused_api_keys",
        mitigationType: "revoke_api_key",
      },
      type: "governance_control_detection",
    },
  },
};

apiInstance
  .mitigateGovernanceDetections(params)
  .then((data: any) => {
    console.log(
      "API called successfully. Returned data: " + JSON.stringify(data)
    );
  })
  .catch((error: any) => console.error(error));
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=typescript) and then save the example to `example.ts` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" tsc "example.ts"
{% /tab %}
